from machine import I2C, Pin 
from pico_i2c_lcd import I2cLcd

import random
import time
import utime


led_yR = Pin(0, Pin.OUT)
led_yG = Pin(1, Pin.OUT)

i2c = I2C(0, sda = Pin(4), scl = Pin(5), freq = 400000)

pb_an2 = Pin(6, Pin.IN, Pin.PULL_DOWN)
pb_an3 = Pin(7, Pin.IN, Pin.PULL_DOWN)
pb_na2 = Pin(8, Pin.IN, Pin.PULL_DOWN)
pb_na3 = Pin(9, Pin.IN, Pin.PULL_DOWN)
pb_no2 = Pin(10, Pin.IN, Pin.PULL_DOWN)
pb_no3 = Pin(11, Pin.IN, Pin.PULL_DOWN)
pb_or2 = Pin(12, Pin.IN, Pin.PULL_DOWN)
pb_or3 = Pin(13, Pin.IN, Pin.PULL_DOWN)
pb_xo2 = Pin(14, Pin.IN, Pin.PULL_DOWN)
pb_xn2 = Pin(15, Pin.IN, Pin.PULL_DOWN)

led_aR = Pin(16, Pin.OUT)
led_aG = Pin(17, Pin.OUT)
led_bR = Pin(18, Pin.OUT)
led_bG = Pin(19, Pin.OUT)
led_cR = Pin(20, Pin.OUT)
led_cG = Pin(21, Pin.OUT)

pb_aIn = Pin(22, Pin.IN, Pin.PULL_DOWN)
pb_bIn = Pin(26, Pin.IN, Pin.PULL_DOWN)
pb_cIn = Pin(27, Pin.IN, Pin.PULL_DOWN)

pb_res = Pin(28, Pin.IN, Pin.PULL_DOWN)


I2C_ADDR = i2c.scan()[0]
lcd = I2cLcd(i2c, I2C_ADDR, 2, 16)
                                    
lastTogg_a = time.ticks_ms()
lastTogg_b = time.ticks_ms()
lastTogg_c = time.ticks_ms()

a = 0
b = 0
c = 0

levelNumber = 0
stageScore = 14
totalScore = 140
finalPercent = 0
fRandom = random.randint(1, 2)

playLevels = ['2inAND','3inAND','2inNAND','3inNAND','2inNOR','3inNOR','2inOR','3inOR','2inXOR','2inXNOR']

    
def and2(a, b):
    if a == 1 and b == 1:
        return True
    else:
        return False
    
def and3(a, b, c):
    if a == 1 and b == 1 and c == 1:
        return True
    else:
        return False
    
def nand2(a, b):
    if a == 1 and b == 1:
        return False
    else:
        return True
    
def nand3(a, b, c):
    if a == 1 and b == 1 and c == 1:
        return False
    else:
        return True
    
def nor2(a, b):
    if a == 0 and b == 0:
        return True
    else:
        return False
    
def nor3(a, b, c):
    if a == 0 and b == 0 and c == 0:
        return True
    else:
        return False
    
def or2(a, b):
    if a == 0 and b == 0:
        return False
    else:
        return True
    
def or3(a, b, c):
    if a == 0 and b == 0 and c == 0:
        return False
    else:
        return True
    
def xor2(a, b):
    if a != b:
        return True
    else:
        return False
    
def xnor2(a, b):
    if a == b:
        return True
    else:
        return False

def gateCall(ID):
    if ID == '2inAND':
        return and2(a, b)
    elif ID == '3inAND':
        return and3(a, b, c)
    elif ID == '2inNAND':
        return nand2(a, b)
    elif ID == '3inNAND':
        return nand3(a, b, c)
    elif ID == '2inNOR':
        return nor2(a, b)
    elif ID == '3inNOR':
        return nor3(a, b, c)
    elif ID == '2inOR':
        return or2(a, b)
    elif ID == '3inOR':
        return or3(a, b, c)
    elif ID == '2inXOR':
        return xor2(a, b)
    elif ID == '2inXNOR':
        return xnor2(a, b)

def inpStart(argID):
    if argID == '2inAND' or argID == '2inNAND' or argID == '2inNOR' or argID == '2inOR' or argID == '2inXOR' or argID == '2inXNOR':
        led_aR.value(1)
        led_aG.value(0)
        led_bR.value(1)
        led_bG.value(0)
        led_cR.value(0)
        led_cG.value(0)
        cNull()
    elif argID == '3inAND' or argID == '3inNAND' or argID == '3inNOR' or argID == '3inOR':
        led_aR.value(1)
        led_aG.value(0)
        led_bR.value(1)
        led_bG.value(0)
        led_cR.value(1)
        led_cG.value(0)

def cNull():
    global c
    c = 'N/A'

def outSetter(logic):
    if logic == True:
        led_yR.value(0)
        led_yG.value(1)
    else:
        led_yR.value(1)
        led_yG.value(0)

def inpReset():
    global a, b, c
    a = 0
    b = 0
    c = 0

def scoreReset():
    global stageScore
    stageScore = 14

def scoreDeduct():
    global stageScore, totalScore
    totalScore = totalScore - stageScore

def scorePercent():
    global finalPercent, totalScore
    finalPercent = str(round(float((totalScore / 140)*100),1))

def playDisp():
    lcd.clear()
    lcd.putstr('NAME!THAT!GATE! \n'
               'Score: '+ str(totalScore) +'')
        
def cNotValDisp():
    lcd.clear()
    lcd.putstr('INP(C) NOT VALID\n'
               'Score: '+ str(totalScore) +'')

def rightDisp():
    lcd.clear()
    lcd.putstr('Correct!!       \n'
               'Gate: '+ playLevels[levelNumber] +'')

def wrongDisp():
    lcd.clear()
    lcd.putstr('Incorrect..     \n'
               'Gate: '+ playLevels[levelNumber] +'')
    
def endDisp():
    lcd.clear()
    lcd.putstr('Finished! '+ str(finalPercent) +'%\n'
               'Final Score: '+ str(totalScore) +'')

def funDisp():
    global totalScore, fRandom
    if totalScore >= 134:
        lcd.clear()
        lcd.putstr('Wise AND lucky!?\n')        
    elif totalScore >= 132:
        lcd.clear()
        lcd.putstr('Go build a dam!!\n')
    elif totalScore >= 126:
        lcd.clear()
        lcd.putstr('Not just a land \n'
                   'tiller huh?\n')
    elif totalScore >= 112:
        lcd.clear()
        lcd.putstr('We can spare the\n'
                   'ID-10-T error\n')
    elif totalScore >= 98:
        lcd.clear()
        lcd.putstr('Better lay off  \n'
                   'the markers bud\n')
    else:
        if fRandom == 1:
            lcd.clear()
            lcd.putstr('Out of your     \n'
                       'element kitty!\n')
        elif fRandom == 2:
            lcd.clear()
            lcd.putstr('Buzz off!       \n')

def rightFlash():
    for i in range(1):
        led_aR.value(0)
        led_aG.value(1)
        led_bR.value(0)
        led_bG.value(1)
        led_cR.value(0)
        led_cG.value(1)
        led_yR.value(0)
        led_yG.value(1)
        time.sleep(0.25)
    for i in range(7):
        led_aG.toggle()
        led_bG.toggle()
        led_cG.toggle()
        led_yG.toggle()
        time.sleep(0.25)

def wrongFlash():
    for i in range(1):
        led_aR.value(1)
        led_aG.value(0)
        led_bR.value(1)
        led_bG.value(0)
        led_cR.value(1)
        led_cG.value(0)
        led_yR.value(1)
        led_yG.value(0)
        time.sleep(0.25)
    for i in range(7):
        led_aR.toggle()
        led_bR.toggle()
        led_cR.toggle()
        led_yR.toggle()
        time.sleep(0.25)

def inpEnd():
    led_aR.value(1)
    led_aG.value(0)
    led_bR.value(0)
    led_bG.value(1)
    led_cR.value(1)
    led_cG.value(0)
    led_yR.value(0)
    led_yG.value(1)

def endTogg():
    led_aR.toggle()
    led_aG.toggle()
    led_bR.toggle()
    led_bG.toggle()
    led_cR.toggle()
    led_cG.toggle()
    led_yR.toggle()
    led_yG.toggle()

def inpToggler(inpButton):
    global a, b, c, lastTogg_a, lastTogg_b, lastTogg_c, pb_aIn, pb_bIn, pb_cIn, notValid_c, stageScore, totalScore
    if inpButton is pb_aIn and a == 0:
        if time.ticks_diff(time.ticks_ms(), lastTogg_a) > 500:
            if stageScore != 0:
                a = a + 1
                led_aR.toggle()
                led_aG.toggle()
                outSetter(gateCall(playLevels[levelNumber]))
                stageScore = stageScore - 1
                totalScore = totalScore - 1
                playDisp()
                lastTogg_a = time.ticks_ms()
                lastTogg_b = time.ticks_ms()
                lastTogg_c = time.ticks_ms()
            elif stageScore == 0:
                a = a + 1
                led_aR.toggle()
                led_aG.toggle()
                outSetter(gateCall(playLevels[levelNumber]))
                lastTogg_a = time.ticks_ms()
                lastTogg_b = time.ticks_ms()
                lastTogg_c = time.ticks_ms()
    elif inpButton is pb_aIn and a == 1:
        if time.ticks_diff(time.ticks_ms(), lastTogg_a) > 500:
            if stageScore != 0:
                a = a - 1
                led_aR.toggle()
                led_aG.toggle()
                outSetter(gateCall(playLevels[levelNumber]))
                stageScore = stageScore - 1
                totalScore = totalScore - 1
                playDisp()
                lastTogg_a = time.ticks_ms()
                lastTogg_b = time.ticks_ms()
                lastTogg_c = time.ticks_ms()
            elif stageScore == 0:
                a = a - 1
                led_aR.toggle()
                led_aG.toggle()
                outSetter(gateCall(playLevels[levelNumber]))
                lastTogg_a = time.ticks_ms()
                lastTogg_b = time.ticks_ms()
                lastTogg_c = time.ticks_ms()
    elif inpButton is pb_bIn and b == 0:
        if time.ticks_diff(time.ticks_ms(), lastTogg_b) > 500:
            if stageScore != 0:
                b = b + 1
                led_bR.toggle()
                led_bG.toggle()
                outSetter(gateCall(playLevels[levelNumber]))
                stageScore = stageScore - 1
                totalScore = totalScore - 1
                playDisp()
                lastTogg_b = time.ticks_ms()
                lastTogg_c = time.ticks_ms()
                lastTogg_a = time.ticks_ms()
            elif stageScore == 0:
                b = b + 1
                led_bR.toggle()
                led_bG.toggle()
                outSetter(gateCall(playLevels[levelNumber]))
                lastTogg_b = time.ticks_ms()
                lastTogg_c = time.ticks_ms()
                lastTogg_a = time.ticks_ms()
    elif inpButton is pb_bIn and b == 1:
        if time.ticks_diff(time.ticks_ms(), lastTogg_b) > 500:
            if stageScore != 0:
                b = b - 1
                led_bR.toggle()
                led_bG.toggle()
                outSetter(gateCall(playLevels[levelNumber]))
                stageScore = stageScore - 1
                totalScore = totalScore - 1
                playDisp()
                lastTogg_b = time.ticks_ms()
                lastTogg_c = time.ticks_ms()
                lastTogg_a = time.ticks_ms()
            elif stageScore == 0:
                b = b - 1
                led_bR.toggle()
                led_bG.toggle()
                outSetter(gateCall(playLevels[levelNumber]))
                lastTogg_b = time.ticks_ms()
                lastTogg_c = time.ticks_ms()
                lastTogg_a = time.ticks_ms()
    elif inpButton is pb_cIn and c == 0:
        if time.ticks_diff(time.ticks_ms(), lastTogg_c) > 500:
            if stageScore != 0:
                c = c + 1
                led_cR.toggle()
                led_cG.toggle()
                outSetter(gateCall(playLevels[levelNumber]))
                stageScore = stageScore - 1
                totalScore = totalScore - 1
                playDisp()
                lastTogg_c = time.ticks_ms()
                lastTogg_a = time.ticks_ms()
                lastTogg_b = time.ticks_ms()
            elif stageScore == 0:
                c = c + 1
                led_cR.toggle()
                led_cG.toggle()
                outSetter(gateCall(playLevels[levelNumber]))
                lastTogg_c = time.ticks_ms()
                lastTogg_a = time.ticks_ms()
                lastTogg_b = time.ticks_ms()
    elif inpButton is pb_cIn and c == 1:
        if time.ticks_diff(time.ticks_ms(), lastTogg_c) > 500:
            if stageScore != 0:
                c = c - 1
                led_cR.toggle()
                led_cG.toggle()
                outSetter(gateCall(playLevels[levelNumber]))
                stageScore = stageScore - 1
                totalScore = totalScore - 1
                playDisp()
                lastTogg_c = time.ticks_ms()
                lastTogg_a = time.ticks_ms()
                lastTogg_b = time.ticks_ms()
            elif stageScore == 0:
                c = c - 1
                led_cR.toggle()
                led_cG.toggle()
                outSetter(gateCall(playLevels[levelNumber]))
                lastTogg_c = time.ticks_ms()
                lastTogg_a = time.ticks_ms()
                lastTogg_b = time.ticks_ms()
    elif inpButton is pb_cIn and c == 'N/A':
        if time.ticks_diff(time.ticks_ms(), lastTogg_c) > 500:
            if stageScore != 0:
                stageScore = stageScore - 1
                totalScore = totalScore - 1
                cNotValDisp()
                time.sleep(2)
                playDisp()
                lastTogg_c = time.ticks_ms()
                lastTogg_a = time.ticks_ms()
                lastTogg_b = time.ticks_ms()
            elif stageScore == 0:
                cNotValDisp()
                time.sleep(2)
                lastTogg_c = time.ticks_ms()
                lastTogg_a = time.ticks_ms()
                lastTogg_b = time.ticks_ms()
    elif inpButton is pb_res:
        machine.reset()
        
def randomShuffle(seq):
    l = len(seq)
    for i in range(l):
        j = random.randrange(l)
        seq[i], seq[j] = seq[j], seq[i]
        
                                            
randomShuffle(playLevels)

playDisp()


for i in range(10):    
    pb_aIn.irq(trigger = Pin.IRQ_RISING, handler = inpToggler) 
    pb_bIn.irq(trigger = Pin.IRQ_RISING, handler = inpToggler)
    pb_cIn.irq(trigger = Pin.IRQ_RISING, handler = inpToggler)
    pb_res.irq(trigger = Pin.IRQ_FALLING, handler = inpToggler)
    
    inpStart(playLevels[levelNumber])
    
    outSetter(gateCall(playLevels[levelNumber]))
    
    gateLoaded = playLevels[levelNumber]
    
    if gateLoaded == '2inAND':
        while True:
            if pb_an2.value() == True:
                rightDisp()
                rightFlash()
                break
            elif pb_an3.value() == True or pb_na2.value() == True or pb_na3.value() == True or pb_no2.value() == True or pb_no3.value() == True or pb_or2.value() == True or pb_or3.value() == True or pb_xo2.value() == True or pb_xn2.value() == True:
                wrongDisp()
                wrongFlash()
                scoreDeduct()
                break
    elif gateLoaded == '3inAND':
        while True:
            if pb_an3.value() == True:
                rightDisp()
                rightFlash()
                break
            elif pb_an2.value() == True or pb_na2.value() == True or pb_na3.value() == True or pb_no2.value() == True or pb_no3.value() == True or pb_or2.value() == True or pb_or3.value() == True or pb_xo2.value() == True or pb_xn2.value() == True:
                wrongDisp()
                wrongFlash()
                scoreDeduct()
                break
    elif gateLoaded == '2inNAND':
        while True:
            if pb_na2.value() == True:
                rightDisp()
                rightFlash()
                break
            elif pb_an2.value() == True or pb_an3.value() == True or pb_na3.value() == True or pb_no2.value() == True or pb_no3.value() == True or pb_or2.value() == True or pb_or3.value() == True or pb_xo2.value() == True or pb_xn2.value() == True:
                wrongDisp()
                wrongFlash()
                scoreDeduct()
                break
    elif gateLoaded == '3inNAND':
        while True:
            if pb_na3.value() == True:
                rightDisp()
                rightFlash()
                break
            elif pb_an2.value() == True or pb_an3.value() == True or pb_na2.value() == True or pb_no2.value() == True or pb_no3.value() == True or pb_or2.value() == True or pb_or3.value() == True or pb_xo2.value() == True or pb_xn2.value() == True:
                wrongDisp()
                wrongFlash()
                scoreDeduct()
                break
    elif gateLoaded == '2inNOR':
        while True:
            if pb_no2.value() == True:
                rightDisp()
                rightFlash()
                break
            elif pb_an2.value() == True or pb_an3.value() == True or pb_na2.value() == True or pb_na3.value() == True or pb_no3.value() == True or pb_or2.value() == True or pb_or3.value() == True or pb_xo2.value() == True or pb_xn2.value() == True:
                wrongDisp()
                wrongFlash()
                scoreDeduct()
                break
    elif gateLoaded == '3inNOR':
        while True:
            if pb_no3.value() == True:
                rightDisp()
                rightFlash()
                break
            elif pb_an2.value() == True or pb_an3.value() == True or pb_na2.value() == True or pb_na3.value() == True or pb_no2.value() == True or pb_or2.value() == True or pb_or3.value() == True or pb_xo2.value() == True or pb_xn2.value() == True:
                wrongDisp()
                wrongFlash()
                scoreDeduct()
                break
    elif gateLoaded == '2inOR':
        while True:
            if pb_or2.value() == True:
                rightDisp()
                rightFlash()
                break
            elif pb_an2.value() == True or pb_an3.value() == True or pb_na2.value() == True or pb_na3.value() == True or pb_no2.value() == True or pb_no3.value() == True or pb_or3.value() == True or pb_xo2.value() == True or pb_xn2.value() == True:
                wrongDisp()
                wrongFlash()
                scoreDeduct()
                break
    elif gateLoaded == '3inOR':
        while True:
            if pb_or3.value() == True:
                rightDisp()
                rightFlash()
                break
            elif pb_an2.value() == True or pb_an3.value() == True or pb_na2.value() == True or pb_na3.value() == True or pb_no2.value() == True or pb_no3.value() == True or pb_or2.value() == True or pb_xo2.value() == True or pb_xn2.value() == True:
                wrongDisp()
                wrongFlash()
                scoreDeduct()
                break
    elif gateLoaded == '2inXOR':
        while True:
            if pb_xo2.value() == True:
                rightDisp()
                rightFlash()
                break
            elif pb_an2.value() == True or pb_an3.value() == True or pb_na2.value() == True or pb_na3.value() == True or pb_no2.value() == True or pb_no3.value() == True or pb_or2.value() == True or pb_or3.value() == True or pb_xn2.value() == True:
                wrongDisp()
                wrongFlash()
                scoreDeduct()
                break
    elif gateLoaded == '2inXNOR':
        while True:
            if pb_xn2.value() == True:
                rightDisp()
                rightFlash()
                break
            elif pb_an2.value() == True or pb_an3.value() == True or pb_na2.value() == True or pb_na3.value() == True or pb_no2.value() == True or pb_no3.value() == True or pb_or2.value() == True or pb_or3.value() == True or pb_xo2.value() == True:
                wrongDisp()
                wrongFlash()
                scoreDeduct()
                break
    
    inpReset()
    
    scoreReset()
    
    playDisp()
    
    levelNumber = levelNumber + 1


for i in range(1):    
    pb_res.irq(trigger = Pin.IRQ_FALLING, handler = inpToggler)
    
    inpEnd()
    
    scorePercent()
    
    while True:
        endDisp()
        endTogg()
        time.sleep(1)
        endTogg()
        time.sleep(1)
        funDisp()
        endTogg()
        time.sleep(1)
        endTogg()
        time.sleep(1)